/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the Conversation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Conversation{}

// Conversation struct for Conversation
type Conversation struct {
	Id string `json:"id"`
	ChannelId string `json:"channel_id"`
	GatewayId string `json:"gateway_id"`
	ComChannel CommunicationChannel `json:"com_channel"`
	LastMessage *ConversationMessage `json:"last_message,omitempty"`
	Labels []string `json:"labels,omitempty"`
	CustomData *ConversationCustomData `json:"custom_data,omitempty"`
	OptedIn bool `json:"opted_in"`
	Blocked bool `json:"blocked"`
	BlockedInfo *string `json:"blocked_info,omitempty"`
	OptOutType *string `json:"opt_out_type,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdateAt time.Time `json:"update_at"`
	LastSentMsgAt *time.Time `json:"last_sent_msg_at,omitempty"`
	LastReceivedMsgAt *time.Time `json:"last_received_msg_at,omitempty"`
	LastMsgAt *time.Time `json:"last_msg_at,omitempty"`
	OptedInAt *time.Time `json:"opted_in_at,omitempty"`
	OptedOutAt *time.Time `json:"opted_out_at,omitempty"`
	ReadAt *time.Time `json:"read_at,omitempty"`
	AgentRequested bool `json:"agent_requested"`
	AgentRequestedType *string `json:"agent_requested_type,omitempty"`
	// When true it means that human agent took over this conversation 
	AgentTaken bool `json:"agent_taken"`
	NewMessages int32 `json:"new_messages"`
}

// NewConversation instantiates a new Conversation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversation(id string, channelId string, gatewayId string, comChannel CommunicationChannel, optedIn bool, blocked bool, createdAt time.Time, updateAt time.Time, agentRequested bool, agentTaken bool, newMessages int32) *Conversation {
	this := Conversation{}
	this.Id = id
	this.ChannelId = channelId
	this.GatewayId = gatewayId
	this.ComChannel = comChannel
	this.OptedIn = optedIn
	this.Blocked = blocked
	this.CreatedAt = createdAt
	this.UpdateAt = updateAt
	this.AgentRequested = agentRequested
	this.AgentTaken = agentTaken
	this.NewMessages = newMessages
	return &this
}

// NewConversationWithDefaults instantiates a new Conversation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationWithDefaults() *Conversation {
	this := Conversation{}
	return &this
}

// GetId returns the Id field value
func (o *Conversation) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Conversation) SetId(v string) {
	o.Id = v
}

// GetChannelId returns the ChannelId field value
func (o *Conversation) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *Conversation) SetChannelId(v string) {
	o.ChannelId = v
}

// GetGatewayId returns the GatewayId field value
func (o *Conversation) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *Conversation) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetComChannel returns the ComChannel field value
func (o *Conversation) GetComChannel() CommunicationChannel {
	if o == nil {
		var ret CommunicationChannel
		return ret
	}

	return o.ComChannel
}

// GetComChannelOk returns a tuple with the ComChannel field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetComChannelOk() (*CommunicationChannel, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ComChannel, true
}

// SetComChannel sets field value
func (o *Conversation) SetComChannel(v CommunicationChannel) {
	o.ComChannel = v
}

// GetLastMessage returns the LastMessage field value if set, zero value otherwise.
func (o *Conversation) GetLastMessage() ConversationMessage {
	if o == nil || IsNil(o.LastMessage) {
		var ret ConversationMessage
		return ret
	}
	return *o.LastMessage
}

// GetLastMessageOk returns a tuple with the LastMessage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetLastMessageOk() (*ConversationMessage, bool) {
	if o == nil || IsNil(o.LastMessage) {
		return nil, false
	}
	return o.LastMessage, true
}

// HasLastMessage returns a boolean if a field has been set.
func (o *Conversation) HasLastMessage() bool {
	if o != nil && !IsNil(o.LastMessage) {
		return true
	}

	return false
}

// SetLastMessage gets a reference to the given ConversationMessage and assigns it to the LastMessage field.
func (o *Conversation) SetLastMessage(v ConversationMessage) {
	o.LastMessage = &v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *Conversation) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *Conversation) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *Conversation) SetLabels(v []string) {
	o.Labels = v
}

// GetCustomData returns the CustomData field value if set, zero value otherwise.
func (o *Conversation) GetCustomData() ConversationCustomData {
	if o == nil || IsNil(o.CustomData) {
		var ret ConversationCustomData
		return ret
	}
	return *o.CustomData
}

// GetCustomDataOk returns a tuple with the CustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetCustomDataOk() (*ConversationCustomData, bool) {
	if o == nil || IsNil(o.CustomData) {
		return nil, false
	}
	return o.CustomData, true
}

// HasCustomData returns a boolean if a field has been set.
func (o *Conversation) HasCustomData() bool {
	if o != nil && !IsNil(o.CustomData) {
		return true
	}

	return false
}

// SetCustomData gets a reference to the given ConversationCustomData and assigns it to the CustomData field.
func (o *Conversation) SetCustomData(v ConversationCustomData) {
	o.CustomData = &v
}

// GetOptedIn returns the OptedIn field value
func (o *Conversation) GetOptedIn() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.OptedIn
}

// GetOptedInOk returns a tuple with the OptedIn field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetOptedInOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OptedIn, true
}

// SetOptedIn sets field value
func (o *Conversation) SetOptedIn(v bool) {
	o.OptedIn = v
}

// GetBlocked returns the Blocked field value
func (o *Conversation) GetBlocked() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetBlockedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Blocked, true
}

// SetBlocked sets field value
func (o *Conversation) SetBlocked(v bool) {
	o.Blocked = v
}

// GetBlockedInfo returns the BlockedInfo field value if set, zero value otherwise.
func (o *Conversation) GetBlockedInfo() string {
	if o == nil || IsNil(o.BlockedInfo) {
		var ret string
		return ret
	}
	return *o.BlockedInfo
}

// GetBlockedInfoOk returns a tuple with the BlockedInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetBlockedInfoOk() (*string, bool) {
	if o == nil || IsNil(o.BlockedInfo) {
		return nil, false
	}
	return o.BlockedInfo, true
}

// HasBlockedInfo returns a boolean if a field has been set.
func (o *Conversation) HasBlockedInfo() bool {
	if o != nil && !IsNil(o.BlockedInfo) {
		return true
	}

	return false
}

// SetBlockedInfo gets a reference to the given string and assigns it to the BlockedInfo field.
func (o *Conversation) SetBlockedInfo(v string) {
	o.BlockedInfo = &v
}

// GetOptOutType returns the OptOutType field value if set, zero value otherwise.
func (o *Conversation) GetOptOutType() string {
	if o == nil || IsNil(o.OptOutType) {
		var ret string
		return ret
	}
	return *o.OptOutType
}

// GetOptOutTypeOk returns a tuple with the OptOutType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetOptOutTypeOk() (*string, bool) {
	if o == nil || IsNil(o.OptOutType) {
		return nil, false
	}
	return o.OptOutType, true
}

// HasOptOutType returns a boolean if a field has been set.
func (o *Conversation) HasOptOutType() bool {
	if o != nil && !IsNil(o.OptOutType) {
		return true
	}

	return false
}

// SetOptOutType gets a reference to the given string and assigns it to the OptOutType field.
func (o *Conversation) SetOptOutType(v string) {
	o.OptOutType = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Conversation) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Conversation) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdateAt returns the UpdateAt field value
func (o *Conversation) GetUpdateAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdateAt
}

// GetUpdateAtOk returns a tuple with the UpdateAt field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetUpdateAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdateAt, true
}

// SetUpdateAt sets field value
func (o *Conversation) SetUpdateAt(v time.Time) {
	o.UpdateAt = v
}

// GetLastSentMsgAt returns the LastSentMsgAt field value if set, zero value otherwise.
func (o *Conversation) GetLastSentMsgAt() time.Time {
	if o == nil || IsNil(o.LastSentMsgAt) {
		var ret time.Time
		return ret
	}
	return *o.LastSentMsgAt
}

// GetLastSentMsgAtOk returns a tuple with the LastSentMsgAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetLastSentMsgAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastSentMsgAt) {
		return nil, false
	}
	return o.LastSentMsgAt, true
}

// HasLastSentMsgAt returns a boolean if a field has been set.
func (o *Conversation) HasLastSentMsgAt() bool {
	if o != nil && !IsNil(o.LastSentMsgAt) {
		return true
	}

	return false
}

// SetLastSentMsgAt gets a reference to the given time.Time and assigns it to the LastSentMsgAt field.
func (o *Conversation) SetLastSentMsgAt(v time.Time) {
	o.LastSentMsgAt = &v
}

// GetLastReceivedMsgAt returns the LastReceivedMsgAt field value if set, zero value otherwise.
func (o *Conversation) GetLastReceivedMsgAt() time.Time {
	if o == nil || IsNil(o.LastReceivedMsgAt) {
		var ret time.Time
		return ret
	}
	return *o.LastReceivedMsgAt
}

// GetLastReceivedMsgAtOk returns a tuple with the LastReceivedMsgAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetLastReceivedMsgAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastReceivedMsgAt) {
		return nil, false
	}
	return o.LastReceivedMsgAt, true
}

// HasLastReceivedMsgAt returns a boolean if a field has been set.
func (o *Conversation) HasLastReceivedMsgAt() bool {
	if o != nil && !IsNil(o.LastReceivedMsgAt) {
		return true
	}

	return false
}

// SetLastReceivedMsgAt gets a reference to the given time.Time and assigns it to the LastReceivedMsgAt field.
func (o *Conversation) SetLastReceivedMsgAt(v time.Time) {
	o.LastReceivedMsgAt = &v
}

// GetLastMsgAt returns the LastMsgAt field value if set, zero value otherwise.
func (o *Conversation) GetLastMsgAt() time.Time {
	if o == nil || IsNil(o.LastMsgAt) {
		var ret time.Time
		return ret
	}
	return *o.LastMsgAt
}

// GetLastMsgAtOk returns a tuple with the LastMsgAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetLastMsgAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastMsgAt) {
		return nil, false
	}
	return o.LastMsgAt, true
}

// HasLastMsgAt returns a boolean if a field has been set.
func (o *Conversation) HasLastMsgAt() bool {
	if o != nil && !IsNil(o.LastMsgAt) {
		return true
	}

	return false
}

// SetLastMsgAt gets a reference to the given time.Time and assigns it to the LastMsgAt field.
func (o *Conversation) SetLastMsgAt(v time.Time) {
	o.LastMsgAt = &v
}

// GetOptedInAt returns the OptedInAt field value if set, zero value otherwise.
func (o *Conversation) GetOptedInAt() time.Time {
	if o == nil || IsNil(o.OptedInAt) {
		var ret time.Time
		return ret
	}
	return *o.OptedInAt
}

// GetOptedInAtOk returns a tuple with the OptedInAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetOptedInAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.OptedInAt) {
		return nil, false
	}
	return o.OptedInAt, true
}

// HasOptedInAt returns a boolean if a field has been set.
func (o *Conversation) HasOptedInAt() bool {
	if o != nil && !IsNil(o.OptedInAt) {
		return true
	}

	return false
}

// SetOptedInAt gets a reference to the given time.Time and assigns it to the OptedInAt field.
func (o *Conversation) SetOptedInAt(v time.Time) {
	o.OptedInAt = &v
}

// GetOptedOutAt returns the OptedOutAt field value if set, zero value otherwise.
func (o *Conversation) GetOptedOutAt() time.Time {
	if o == nil || IsNil(o.OptedOutAt) {
		var ret time.Time
		return ret
	}
	return *o.OptedOutAt
}

// GetOptedOutAtOk returns a tuple with the OptedOutAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetOptedOutAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.OptedOutAt) {
		return nil, false
	}
	return o.OptedOutAt, true
}

// HasOptedOutAt returns a boolean if a field has been set.
func (o *Conversation) HasOptedOutAt() bool {
	if o != nil && !IsNil(o.OptedOutAt) {
		return true
	}

	return false
}

// SetOptedOutAt gets a reference to the given time.Time and assigns it to the OptedOutAt field.
func (o *Conversation) SetOptedOutAt(v time.Time) {
	o.OptedOutAt = &v
}

// GetReadAt returns the ReadAt field value if set, zero value otherwise.
func (o *Conversation) GetReadAt() time.Time {
	if o == nil || IsNil(o.ReadAt) {
		var ret time.Time
		return ret
	}
	return *o.ReadAt
}

// GetReadAtOk returns a tuple with the ReadAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetReadAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ReadAt) {
		return nil, false
	}
	return o.ReadAt, true
}

// HasReadAt returns a boolean if a field has been set.
func (o *Conversation) HasReadAt() bool {
	if o != nil && !IsNil(o.ReadAt) {
		return true
	}

	return false
}

// SetReadAt gets a reference to the given time.Time and assigns it to the ReadAt field.
func (o *Conversation) SetReadAt(v time.Time) {
	o.ReadAt = &v
}

// GetAgentRequested returns the AgentRequested field value
func (o *Conversation) GetAgentRequested() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.AgentRequested
}

// GetAgentRequestedOk returns a tuple with the AgentRequested field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetAgentRequestedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AgentRequested, true
}

// SetAgentRequested sets field value
func (o *Conversation) SetAgentRequested(v bool) {
	o.AgentRequested = v
}

// GetAgentRequestedType returns the AgentRequestedType field value if set, zero value otherwise.
func (o *Conversation) GetAgentRequestedType() string {
	if o == nil || IsNil(o.AgentRequestedType) {
		var ret string
		return ret
	}
	return *o.AgentRequestedType
}

// GetAgentRequestedTypeOk returns a tuple with the AgentRequestedType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Conversation) GetAgentRequestedTypeOk() (*string, bool) {
	if o == nil || IsNil(o.AgentRequestedType) {
		return nil, false
	}
	return o.AgentRequestedType, true
}

// HasAgentRequestedType returns a boolean if a field has been set.
func (o *Conversation) HasAgentRequestedType() bool {
	if o != nil && !IsNil(o.AgentRequestedType) {
		return true
	}

	return false
}

// SetAgentRequestedType gets a reference to the given string and assigns it to the AgentRequestedType field.
func (o *Conversation) SetAgentRequestedType(v string) {
	o.AgentRequestedType = &v
}

// GetAgentTaken returns the AgentTaken field value
func (o *Conversation) GetAgentTaken() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.AgentTaken
}

// GetAgentTakenOk returns a tuple with the AgentTaken field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetAgentTakenOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AgentTaken, true
}

// SetAgentTaken sets field value
func (o *Conversation) SetAgentTaken(v bool) {
	o.AgentTaken = v
}

// GetNewMessages returns the NewMessages field value
func (o *Conversation) GetNewMessages() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.NewMessages
}

// GetNewMessagesOk returns a tuple with the NewMessages field value
// and a boolean to check if the value has been set.
func (o *Conversation) GetNewMessagesOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NewMessages, true
}

// SetNewMessages sets field value
func (o *Conversation) SetNewMessages(v int32) {
	o.NewMessages = v
}

func (o Conversation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Conversation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["com_channel"] = o.ComChannel
	if !IsNil(o.LastMessage) {
		toSerialize["last_message"] = o.LastMessage
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	if !IsNil(o.CustomData) {
		toSerialize["custom_data"] = o.CustomData
	}
	toSerialize["opted_in"] = o.OptedIn
	toSerialize["blocked"] = o.Blocked
	if !IsNil(o.BlockedInfo) {
		toSerialize["blocked_info"] = o.BlockedInfo
	}
	if !IsNil(o.OptOutType) {
		toSerialize["opt_out_type"] = o.OptOutType
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["update_at"] = o.UpdateAt
	if !IsNil(o.LastSentMsgAt) {
		toSerialize["last_sent_msg_at"] = o.LastSentMsgAt
	}
	if !IsNil(o.LastReceivedMsgAt) {
		toSerialize["last_received_msg_at"] = o.LastReceivedMsgAt
	}
	if !IsNil(o.LastMsgAt) {
		toSerialize["last_msg_at"] = o.LastMsgAt
	}
	if !IsNil(o.OptedInAt) {
		toSerialize["opted_in_at"] = o.OptedInAt
	}
	if !IsNil(o.OptedOutAt) {
		toSerialize["opted_out_at"] = o.OptedOutAt
	}
	if !IsNil(o.ReadAt) {
		toSerialize["read_at"] = o.ReadAt
	}
	toSerialize["agent_requested"] = o.AgentRequested
	if !IsNil(o.AgentRequestedType) {
		toSerialize["agent_requested_type"] = o.AgentRequestedType
	}
	toSerialize["agent_taken"] = o.AgentTaken
	toSerialize["new_messages"] = o.NewMessages
	return toSerialize, nil
}

type NullableConversation struct {
	value *Conversation
	isSet bool
}

func (v NullableConversation) Get() *Conversation {
	return v.value
}

func (v *NullableConversation) Set(val *Conversation) {
	v.value = val
	v.isSet = true
}

func (v NullableConversation) IsSet() bool {
	return v.isSet
}

func (v *NullableConversation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversation(val *Conversation) *NullableConversation {
	return &NullableConversation{value: val, isSet: true}
}

func (v NullableConversation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


